<!doctype html public "-/w3c/dtd html 4.0 transitional/en">
<html>
<head>
   <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
   <meta name="GENERATOR" content="Mozilla/4.5 [en] (X11; I; SunOS 5.6 sun4u) [Netscape]">
   <title>LDAS database description</title>
</head>
<body>
<b><font size=+1>Transmission rates of ilwd elements through data socket</font></b>
<p>
Test scripts for running the data socket test can be checked out from
the ldas cvs repository subdirectory: <i>ldas/api/genericAPI/tcl/test</i>.
<p>
The procedure to measure the tranmission through data sockets is done as follows:
<ol>
<li>Start up a data socket test API server at port 9000 on each of the test machines
by typing <p><i>datasock_tester.tcl test_server</i></li><p>
<li>Start up a data socket test API client at port 7000 on each of the test machines
by typing <p><i>datasock_tester.tcl test_client</i></li><p>
<li>Create an ascii host file that looks like
<pre>
#
# datasock_hostfile on the same network, will compete for bandwidth between boxes
#
seq=0 client=dataserver server=dataserver   dims=all types=all withcont=0
seq=1 client=dataserver server=dataserver   dims=all types=all withcont=1
seq=2 client=controlmon server=controlmon   dims=all types=all withcont=0
seq=3 client=controlmon server=controlmon   dims=all types=all withcont=1
seq=4 client=dataserver server=sunbox1      dims=all types=all withcont=0
seq=5 client=dataserver server=sunbox1      dims=all types=all withcont=1
seq=6 client=controlmon server=linuxbox1    dims=all types=all withcont=0
seq=7 client=controlmon server=linuxbox1    dims=all types=all withcont=1
seq=8 client=dataserver server=controlmon   dims=all types=all withcont=0
seq=9 client=dataserver server=controlmon   dims=all types=all withcont=1
seq=10 client=controlmon server=dataserver  dims=all types=all withcont=0
seq=11 client=controlmon server=dataserver  dims=all types=all withcont=1
</pre>

<li>On the control machine (any machine), start the test with test driver script datasock_driver.tcl and name
of host file as argument, e.g. <p><i> datasock_driver.tcl datasock_hostfile</i></li><p>
</ol>
<p>
Sequence of events during the test:
<ol>
<li>The test driver gets instructions for each test from the input file. Foreach
test the test driver does the following: <p>
<ol>
<li>The test driver commands the server to be ready to accept the connection from
the client. </li>
<li>The test driver commands the client to run a specific test based on the arguments
passed to the client. </li>
<li>The client reads an ilwd file that has the ilwd type and array size matching
the request arguments and instantiates an ilwd object.</li>
<li>The client turns on the timer to get ready to send ojbect. If container is request,
it sends the entire container; otherwise
only the array element is sent. The client nows waits for the return from server.</li>
<li>The server receives the element from the socket and instantiates an ilwd object;
it immediately sends the object back to the client through a data socket connected
to the client; it closes the data socket right after the send is completed.
<li>The client receives the object and marks end of the timing; it computes the
roundtrip time for sending and receiving the object and saves it. It then repeats
the sending/receiving for the same object 100 times for later calculations.
<li>At the end of 100 sends, the client computes the mean wall and cpu time taken and
standard deviation and cofficient of variation values. It outputs to a local
file these values for the ilwd type and dimension.
<li>If there are more ilwd types and dimensions, the client repeats steps 3 - 7.</li>
<li>Upon completion, it returns a message back to the test driver. </li>
</ol>
<p>
<li>When the driver gets a test completion message, it moves on to the next test in the input file
until all tests are run.
</li>
</ol>
</ol>
<table cellpadding=3 border type=1>
<caption align=center><b>Results of Data Socket Tests on CIT machines</b></caption>
<font size=-2>
<p>
<tr>
    <td align=left width=100><br>Client \ Server</td>
    <th>dataserver<BR>(Sun 450)</th>
    <th>sunbox1<BR>(Sun Ultra 10)</th>
    <th>controlmon<BR>(Linux Pentium)</th>
    <th>linuxbox1<BR>(Linux Pentium)</th></b>
</tr>
<tr>
    <th align=left width=100>dataserver<BR>(Sun box)</th>
    <td><a href="dataserver_dataserver_withcont.html" href="dataserver_dataserver_withoutcont.html" >
        with container<BR>without container</td>
    <td><a href="dataserver_sunbox1_withcont.html" href="dataserver_sunbox1_withoutcont.html" >
        with container<BR>without container</td>
    <td><a href="dataserver_controlmon_withcont.html" href="dataserver_controlmon_withoutcont.html"" >
        with container<BR>without container</td>
    <td><BR></td>
</tr>        
    <th align=left width=100>controlmon<BR>(Linux Pentium)</th>
    <td><a href="controlmon_dataserver_withcont.html" href="controlmon_dataserver_withoutcont.html" >
        with container<BR>without container</td>
    <td><BR></td>
    <td><a href="controlmon_controlmon_withcont.html" href="controlmon_controlmon_withoutcont.html" >
        with container<BR>without container</td>
    <td><a href="controlmon_linuxbox1_withcont.html" href="controlmon_linuxbox1_withoutcont.html" >
        with container<BR>without container</td>
        
    
</tr>
</table></font>
<li>


